///
///    This file is part of ILNumerics Community Edition.
///
///    ILNumerics Community Edition - high performance computing for applications.
///    Copyright (C) 2006 - 2012 Haymo Kutschbach, http://ilnumerics.net
///
///    ILNumerics Community Edition is free software: you can redistribute it and/or modify
///    it under the terms of the GNU General Public License version 3 as published by
///    the Free Software Foundation.
///
///    ILNumerics Community Edition is distributed in the hope that it will be useful,
///    but WITHOUT ANY WARRANTY; without even the implied warranty of
///    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
///    GNU General Public License for more details.
///
///    You should have received a copy of the GNU General Public License
///    along with ILNumerics Community Edition. See the file License.txt in the root
///    of your distribution package. If not, see <http://www.gnu.org/licenses/>.
///
///    In addition this software uses the following components and/or licenses: 
///
///    =================================================================================
///    The Open Toolkit Library License
///    
///    Copyright (c) 2006 - 2009 the Open Toolkit library.
///    
///    Permission is hereby granted, free of charge, to any person obtaining a copy
///    of this software and associated documentation files (the "Software"), to deal
///    in the Software without restriction, including without limitation the rights to 
///    use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
///    the Software, and to permit persons to whom the Software is furnished to do
///    so, subject to the following conditions:
///
///    The above copyright notice and this permission notice shall be included in all
///    copies or substantial portions of the Software.
///
///    =================================================================================
///    

using System.Drawing;


namespace ILNumerics.Drawing.Shapes {
    
    public class ILTriangles 
        : ILCompositeShape<C4bV3f> {
 
        #region constructors
        /// <summary>
        /// create triangles, for delayed vertex definition
        /// </summary>
        /// <param name="panel">hosting panel</param>
        /// <param name="numVertices">number of vertices to create. Vertices must be filled 
        /// with data manually afterwards.</param>
        public ILTriangles (ILPanel panel, int numTriangles) 
            : base (panel, numTriangles * 3, 3) {
            m_fillColor = Color.Blue;    
        }
        ///// <summary>
        ///// create triangles 
        ///// </summary>
        ///// <param name="panel">hosting panel</param>
        ///// <param name="X">x coordinates vector </param>
        ///// <param name="Y">y coordinates vector </param>
        ///// <param name="Z">z coordinates vector </param>
        //public ILTriangles (ILPanel panel, ILBaseArray X, ILBaseArray Y, ILBaseArray Z) 
        //    : base (panel,3, X,Y,Z) { }
        ///// <summary>
        ///// create triangles, indexed storage
        ///// </summary>
        ///// <param name="panel">hosting panel</param>
        ///// <param name="X">x coordinates vector </param>
        ///// <param name="Y">y coordinates vector </param>
        ///// <param name="Z">z coordinates vector </param>
        ///// <param name="mapping">Mapping of shapes, composes triangles out of vertices. Matrix having  
        ///// 3 rows. Every element in a column specifies the index of a vertex according to its position in X,Y,Z.
        ///// The 3 elements in a column therefore compose a single triangle. Vertices may 
        ///// get used arbitrary times (or not at all). All elements must be positive integer values in 
        ///// range 0...[<see cref="ILNumerics.Drawing.Shapes.ILShape.VertexCount"/>-1].</param>
        //public ILTriangles (ILPanel panel, ILBaseArray X, ILBaseArray Y, ILBaseArray Z, ILBaseArray mapping) 
        //    : base (panel, 3,X,Y,Z,mapping) { }
        ///// <summary>
        ///// create triangles, flat shading
        ///// </summary>
        ///// <param name="panel">hosting panel</param>
        ///// <param name="X">x coordinates vector </param>
        ///// <param name="Y">y coordinates vector </param>
        ///// <param name="Z">z coordinates vector </param>
        ///// <param name="color">Fill color for all shapes.</param>
        ///// <param name="mapping">Mapping of shapes, composes lit triangles out of vertices. Matrix having  
        ///// 3 rows. Every element in a column specifies the index of a vertex according to its position in X,Y,Z.
        ///// The 3 elements in a column therefore compose a single lit triangle. Vertices may 
        ///// get used arbitrary times (or not at all). All elements must be positive integer values in 
        ///// range 0...[<see cref="ILNumerics.Drawing.Shapes.ILShape.VertexCount"/>-1].</param>
        //public ILTriangles (ILPanel panel, ILBaseArray X, ILBaseArray Y, ILBaseArray Z, Color color, ILBaseArray mapping) 
        //    : base (panel,3,X,Y,Z,mapping) {
        //    m_fillColor = color;
        //}
        ///// <summary>
        ///// create lit triangles, interpolated shading
        ///// </summary>
        ///// <param name="panel">hosting panel</param>
        ///// <param name="X">x coordinates vector </param>
        ///// <param name="Y">y coordinates vector </param>
        ///// <param name="Z">z coordinates vector </param>
        ///// <param name="colors">matrix with <see cref="ILNumerics.Drawing.Shapes.ILShape.VertexCount"/> 
        ///// rows, 3 columns for (R,G,B) or 4 columns for 
        ///// (A,R,G,B) for every vertex specified by X,Y,Z. Elements must range from 0..255. If colors 
        ///// has 3 columns only, alpha values of 255 are used as default.</param>
        ///// <param name="mapping">Mapping of shapes, composes triangles out of vertices. Matrix having  
        ///// 3 rows. Every element in a column specifies the index of a vertex according to its position in X,Y,Z.
        ///// The 3 elements in a column therefore compose a single triangle. Vertices may 
        ///// get used arbitrary times (or not at all). All elements must be positive integer values in 
        ///// range 0...[<see cref="ILNumerics.Drawing.Shapes.ILShape.VertexCount"/>-1].</param>
        //public ILTriangles (ILPanel panel, ILBaseArray X, ILBaseArray Y, ILBaseArray Z, ILBaseArray colors, ILBaseArray mapping) 
        //    : base (panel,3,X,Y,Z,colors,mapping) {
        //    m_fillColor = Color.Yellow;
        //}
        #endregion

    }
}
